import java.util.*;
import java.io.*;
public class HashMapSort{
    Map<String, HData> map = new HashMap<>(); 
    void start(){
        readData();
        sortByHeight();  // ύX  
    }
    void readData(){       
        String entry;
        double weight=0, height = 0;
        String name = "";
        try(BufferedReader din = new BufferedReader(new FileReader("listdata.txt"));){
            while ((entry=din.readLine()) != null) {             
                Scanner sc = new Scanner(entry);                 
                if(sc.hasNext()) name = sc.next();               
                if(sc.hasNextDouble()) weight = sc.nextDouble(); 
                if(sc.hasNextDouble())height = sc.nextDouble();  
                map.put(name, new HData(name, weight, height));  
        		sc.close();
            }
        }catch(IOException error) { System.out.println("IOG["); System.exit(1);}
    } 
    // ǉ
    void sortByHeight(){
        List<HData> v = new ArrayList<>(map.values()); 
        System.out.println(v);  // f[^\
        v.sort((x,y)->-Double.compare(x.height, y.height));
        System.out.println(v);  // f[^g̍~ɕ\
        v.sort(Comparator.comparing(x->x.height));
        System.out.println(v);  // f[^g̏ɕ\
    }    
    // ܂
    void search(String nn){
        HData r = map.get(nn);                         //MapL[̒l
        if(r==null){System.out.println(nn + "̃f[^͂܂");} 
        else {System.out.println(r); }              //̌ʂ\
    }
    public static void main(String[] args){
        new HashMapSort().start();
    }
    class HData{ //f[^ێp̃NX
        String name;  double weight;  double height;  
        HData (String name, double weight, double height){
            this.name = name; this.weight = weight;  this.height = height;
        }
        @Override  public String toString(){
            return("("+ name + ":" + weight+", "+ height +")");
        }
    }
}
