// Binding
import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.control.*;  //Slider etc.
import javafx.scene.layout.*;  //VBox
import javafx.geometry.*;  // Pos
import javafx.util.converter.*; //NumberStringConverter

public class BindingExample2 extends Application {
	@Override
	public void start(Stage pstage) {
		Slider slider = new Slider(0, 100, 0);
		slider.setShowTickLabels(true);
		slider.setShowTickMarks(true);
		slider.setPrefWidth(200);
		TextField tf = new TextField("0.0");
		//Ŝ̔zu
		VBox root = new VBox(20);
		root.setAlignment(Pos.CENTER);
		root.setPadding(new Insets(20, 20, 20, 20));
		root.getChildren().addAll(slider, tf);
		Scene scene = new Scene(root);
		pstage.setTitle("Bindings");
		pstage.setScene(scene);
		pstage.show();

		//XC_[ƃeLXgtB[h̑õoCfBO
		tf.textProperty().bindBidirectional(slider.valueProperty(), new NumberStringConverter());

		//_ȉ2̕\
		//tf.textProperty().bindBidirectional(slider.valueProperty(), new NumberStringConverter("#.##"));

		//õoCfBÔ͎悤ɂ
		//Bindings.bindBidirectional(tf.textProperty(), slider.valueProperty(), new NumberStringConverter());
	}
	public static void main(String[] args) {
		launch(args);
    }
}
