import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.*;  //Pane
import javafx.scene.canvas.*;  //Canvas, GraphicsContext
import javafx.scene.paint.Color;

public class CanvasMoveByMouse extends Application {
	Canvas canvas;
	double fX, fY; //lp`pŏ̈ʒu
	double sX, sY; //}EXhbOJ[\̈ʒu
	double x1, y1, x2, y2; //`p̍W
	@Override
	public void start(Stage pstage) {
		Pane root = new Pane();
		canvas = new Canvas(250, 250);
		drawCanvas(50, 50, 200, 200);
		root.getChildren().add(canvas);
		fX = 50;  //ŏ̎lpp̈ʒu
		fY = 50;
		canvas.setOnMouseDragged((event) -> {
			sX = event.getX();
			sY = event.getY();
			adjustPoint();
			drawCanvas(x1, y1, x2, y2);
	    });
		Scene scene = new Scene(root);
		pstage.setTitle("Canvas Example");
		pstage.setScene(scene);
		pstage.show();
    }
    
	void drawCanvas(double x1, double y1, double x2, double y2) {
		GraphicsContext gc = canvas.getGraphicsContext2D();
		gc.clearRect(0, 0, gc.getCanvas().getWidth(), gc.getCanvas().getHeight());
		gc.setStroke(Color.RED);
		gc.setLineWidth(3);
		gc.strokeRect(x1, y1, x2-x1, y2-y1);
		gc.strokeLine(x1, y2, x2, y1);   // 
		gc.strokeLine(x1, y1, x2, y2);
    }

	void adjustPoint(){ //hbO̍Wn߂̓_菬ꍇ̏
		if(sX>=fX && sY>=fY) { //EփhbO ύXȂ
			x1=fX; x2=sX;
			y1=fY; y2=sY;
		}else if(sX<fX && sY<fY){ //փhbO W
			x1=sX; x2=fX;
			y1=sY; y2=fY;
		}else if(sX>=fX && sY<fY){ //EփhbO W
			x1=fX; x2=sX;
			y1=sY; y2=fY;
		}else if(sX<fX && sY>=fY){ //փhbO W
			x1=sX; x2=fX;
			y1=fY; y2=sY;
		}
	}
    public static void main(String... args) {
        launch(args);
    }    
}
