import javafx.scene.shape.*;  //Circle
import javafx.scene.paint.*; //Color
import javafx.animation.*; //Transition
import javafx.util.*;      //Duration

public class Firefly extends Circle {
	double lastSize = 20;     //Ō̔a
	double lastTime = 2;      //ŏIt[܂ł̎
	public Firefly(){
		makeLighting();
	}
	public Firefly(double size, double time){
		lastSize = size;
		lastTime = time;
		makeLighting();
	}
	void makeLighting(){
		//hwC~`Of[V F瓧֕ω
		setFill(new RadialGradient(0, 0, 0.5, 0.5, 0.5, true, CycleMethod.NO_CYCLE,
						new Stop(0, Color.YELLOW), new Stop(1, Color.TRANSPARENT)) );
		Timeline tline = new Timeline(               //2̃L[t[ݒ
			new KeyFrame(Duration.seconds(0), new KeyValue(radiusProperty(), 0) ),  //Jñt[
			new KeyFrame(Duration.seconds(lastTime), //lastTimeb̃t[
						new KeyValue(radiusProperty(), lastSize, Interpolator.EASE_IN) )
		);
		tline.setCycleCount(Animation.INDEFINITE);
		tline.setAutoReverse(true);
		tline.play();
    }
}
