import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.*;   //Pane
import javafx.scene.shape.*;  //Circle
import javafx.scene.paint.*; //Color, ImagePattern
import javafx.animation.*; //Transition
import javafx.util.*;      //Duration

public class PathTransitionExample extends Application {
	Pane root;
	Circle cir;
	double w=400, h=400;
	double radius=150;
	PathTransition trans;
	@Override
	public void start(Stage pstage) {
		root = new Pane();
		root.setPrefSize(w, h);
		Scene scene = new Scene(root);
		makeShapes();
		pstage.setTitle("Transition Example");
		pstage.setScene(scene);
		pstage.show();
		trans.play();
    }

	void makeShapes() {
		cir = new Circle(10, Color.RED);
		root.getChildren().add(cir);
		trans = new PathTransition();
		Circle path = new Circle(w/2, h/2, radius); // Aj[ṼpX
		trans.setDuration(Duration.millis(3000));
		trans.setNode(cir);
		trans.setPath(path);  // Aj[ṼpXݒ
		trans.setInterpolator(Interpolator.LINEAR);// ω͈葬x
		trans.setCycleCount(Animation.INDEFINITE);// ̌JԂ
    }

	public static void main(String... args) {
		launch(args);
    }
}
