// csvt@CǂŁC܂Ot`
import java.io.*;
import java.util.*;
import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.chart.*;

public class PopulationLine extends Application {
	ArrayList<Integer> year = new ArrayList<Integer>();  //s, N
	ArrayList<String> name = new ArrayList<String>();  //, n
	ArrayList<ArrayList<Double>> population = new ArrayList<ArrayList <Double>>();  //n悲ƔNƂ̒l
	LineChart<String, Number> chart;
	@Override
	public void start(Stage pstage) {
		dataRead();

		CategoryAxis xAxis = new CategoryAxis();
		NumberAxis yAxis = new NumberAxis();
		xAxis.setLabel("N");
		yAxis.setLabel("l(100l)");
		chart = new LineChart<String, Number> (xAxis, yAxis);  // ܂`[g
		chart.setTitle("E̐l̐");

		createXYData();

		Scene scene = new Scene(chart, 800, 600);
		scene.getStylesheets().add("chartStyle.css");
		pstage.setTitle("World Population");
		pstage.setScene(scene);
		pstage.show();
	}

	void dataRead() {   //csvt@Cǂ
		String s;
		try( BufferedReader din = new BufferedReader(new FileReader("population.csv")); ){  
			if((s=din.readLine()) != null){  //1sڂǂ
				Scanner sc = new Scanner(s);
				sc.useDelimiter(",");
				while (sc.hasNextInt()) {  //lǂ
					year.add(sc.nextInt());
				}
				sc.close();
			}
			//System.out.println(year);
			while( (s=din.readLine()) != null ){  //2sڈȍ~ǂ
				Scanner sc = new Scanner(s);     
				sc.useDelimiter(",");
				String area = null;   //n
				if(sc.hasNext()) {
					area = sc.next();  //ǂ
					name.add(area);
				}
				ArrayList<Double> row = new ArrayList<Double>(); //s̃f[^ 
				while (sc.hasNextDouble()) {  //lǂ
					row.add(sc.nextDouble());
				}
				sc.close();
				//System.out.println(area + "  " + row);
				population.add(row);
			} 
		}catch(IOException error) { System.out.println("ǂݍ݃G[");}
	}

	void createXYData(){  //Ŏ󂯎XYChartɃf[^ݒ
		for(int i=0; i<population.size(); i++){  //n悲Ƃ
			XYChart.Series<String, Number> series = new XYChart.Series<String, Number>();  // 錧̐
			series.setName(name.get(i));
			for(int j=0; j<year.size(); j++){  // ܂̒lݒCN肩
			series.getData().add(new XYChart.Data<>(year.get(j).toString(), 
									population.get(i).get(j).doubleValue()));
			}
			chart.getData().add(series);  // OtɂЂƂ̒n̐f[^ǉ
		}
	}

	public static void main(String[] args){
		launch(args);
   }
}
