// ȈՃeLXgGfB^
import javafx.application.Application;
import javafx.stage.*; //Stage, FileChooser
import javafx.scene.Scene;
import javafx.scene.control.*;  // Button
import javafx.scene.layout.*;  // VBox
import javafx.geometry.*;
import javafx.event.*;  //ActionEvent
import java.io.*;  // File

public class TextEditor2 extends Application {
	double w = 600, h = 600;
	TextArea text;
	String charsetname = "UTF8";
	@Override
	public void start(Stage stage) {
		//{^Rei
		Button openb = new Button("J");
		Button saveb = new Button("ۑ");
		Button clearb = new Button("NA");
		ComboBox <String> cb  = new ComboBox<String>();
		cb.getItems().addAll("UTF8", "UTF-16", "SJIS", "ISO2022JP", "EUC_JP");
		cb.getSelectionModel().selectFirst();  //擪I
		HBox lowerPane = new HBox(); 
		lowerPane.setAlignment(Pos.CENTER);
		lowerPane.getChildren().addAll(openb, saveb, clearb, cb);
		lowerPane.setPadding(new Insets(15, 10, 15, 10));
		lowerPane.setSpacing(20);
		//㕔Rei
		ScrollPane upperPane = new ScrollPane();
		upperPane.setPrefSize(w, h);
		upperPane.setFitToHeight(true); //ScrollPane̍Ƀm[h̃TCYύX
		upperPane.setFitToWidth(true); //ScrollPane̕Ƀm[h̃TCYύX
		text = new TextArea();
		upperPane.setContent(text);
	
		VBox root = new VBox();
		root.getChildren().addAll(upperPane, lowerPane);
		Scene scene = new Scene(root);
		stage.setTitle("Text Editor");
		stage.setScene(scene);
		stage.sizeToScene();
		stage.show();
	
		//Cxgnh̐ݒ
		openb.setOnAction((ActionEvent event)-> {
			FileChooser fileChooser = new FileChooser();
			fileChooser.setTitle("Open text from a file");
			File file = fileChooser.showOpenDialog(stage);
			if(file != null) dataRead(file);
		});
		saveb.setOnAction((ActionEvent event) -> {
			FileChooser fileChooser = new FileChooser();
			fileChooser.setTitle("Save Text in a file");
			File file = fileChooser.showSaveDialog(stage);
			if(file != null) dataWrite(file);
		});
		clearb.setOnAction((ActionEvent event) -> {
			text.setText("");
		});
		cb.setOnAction( (ActionEvent event)-> {
			charsetname = (String) cb.getSelectionModel().getSelectedItem();
		});
	}

	void dataRead(File file) {   //sǂŕ\
		try(BufferedReader din = 
			new BufferedReader(
				new InputStreamReader(new FileInputStream(file), charsetname)); )
		{
			String s;
			while((s = din.readLine()) != null){//t@C̏I܂ŁA1sǂ݁A
				text.appendText(new String(s.getBytes("UTF8"), "UTF8"));  //t@C̍stextɒǉ
				text.appendText("\n");
			}
		}catch(IOException e) { System.out.println("ǂݍ݃G["); }
	} 

	void dataWrite(File file) {  //t@Cփf[^
		try(BufferedWriter dout = new BufferedWriter(new FileWriter(file)); )
		{
			dout.write(text.getText());
		} catch(IOException e) { System.out.println("݃G["); }
	}

	public static void main(String... args) {
		launch(args);
    } 
}