import java.util.concurrent.*;
import tg.*;

public class CDLatchExample extends TurtleFrame{
    ExecutorService executor = Executors.newCachedThreadPool();
    CDLatchExample(int num, CountDownLatch start, CountDownLatch finish){
        for(int i = 0; i < num; i++){
            int ii = i;
            executor.execute(()->{
                Turtle m = new HTurtle(0, (ii+1)*50, 90);    add(m);
                int sp = (int)((Math.random()+1)*20);
                m.speed(sp);
                try {
                    start.await();   // ꂼ̃^[g start ̃JEg_E҂
                    m.fd(400);
                    finish.countDown();  // SẴ^[gCfinish ̃JEg_Es
                } catch (InterruptedException e) {}
            });
        }
        executor.shutdown();
    }
    public static void main(String[] args) throws InterruptedException {
        CountDownLatch c1 = new CountDownLatch(1);  // X^[g̃^C~O킹邽
        CountDownLatch c2 = new CountDownLatch(2);  // 1ڂ̃[X̂Qʂ玟̃[XX^[g
        CountDownLatch c3 = new CountDownLatch(2);  // 2ڂ̃[X̂Qʂ玟̃[XX^[g
        CountDownLatch c4 = new CountDownLatch(1);  // NS[CR\[ GOAL ƕ\
        CDLatchExample a1= new CDLatchExample(5, c1, c2); 
        CDLatchExample a2= new CDLatchExample(3, c2, c3);
        CDLatchExample a3= new CDLatchExample(7, c3, c4);
        c1.countDown();         // c1 JEg_EC[XX^[g
        c4.await();              // c4 JEg_E܂ő҂
        System.out.println("GOAL");
    }
}
