import java.util.concurrent.*;
import tg.*;

public class CDLatchExample2 extends TurtleFrame{
    ExecutorService executor = Executors.newCachedThreadPool();
    CDLatchExample2(int num, CDLatch start, CDLatch finish){
        for(int i = 0; i < num; i++){
            int ii = i;
            executor.execute(()->{
                Turtle m = new HTurtle(0, (ii+1)*50, 90);    add(m);
                int sp = (int)((Math.random()+1)*20);
                m.speed(sp);
                try {
                    start.await();   // ꂼ̃^[g start ̃JEg_E҂
                    m.fd(400);
                    finish.countDown();  // SẴ^[gCfinish ̃JEg_Es
                } catch (InterruptedException e) {}
            });
        }
        executor.shutdown();
    }
    public static void main(String[] args) throws InterruptedException {
        CDLatch c1 = new CDLatch(1);  // X^[g̃^C~O킹邽
        CDLatch c2 = new CDLatch(2);  // 1ڂ̃[X̂Qʂ玟̃[XX^[g
        CDLatch c3 = new CDLatch(2);  // 2ڂ̃[X̂Qʂ玟̃[XX^[g
        CDLatch c4 = new CDLatch(1);  // NS[CR\[ GOAL ƕ\
        CDLatchExample2 a1= new CDLatchExample2(5, c1, c2); 
        CDLatchExample2 a2= new CDLatchExample2(3, c2, c3);
        CDLatchExample2 a3= new CDLatchExample2(7, c3, c4);
        c1.countDown();         // c1 JEg_EC[XX^[g
        c4.await();              // c4 JEg_E܂ő҂
        System.out.println("GOAL");
    }
}
