// TextField̓
import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.control.*;  //Label,TextField
import javafx.scene.layout.*;  //GridPane

public class TextFieldEvent extends Application {
	TextField tfH;
	Label laStdW;
	@Override
	public void start(Stage pstage) {
		tfH = new TextField(); //eLXgtB[h
		laStdW = new Label(""); //vZʕ\x
		GridPane root = new GridPane();
		root.addRow(0, new Label("g(cm)"), tfH);
		root.addRow(1, new Label("W̏d(kg)"), laStdW);
		root.getStyleClass().add("gridpane");
		Scene scene = new Scene(root);
		scene.getStylesheets().add("textfieldevent.css");
        pstage.setTitle("Standard Weight");
        pstage.setScene(scene);
		pstage.show();
		//Cxgnh
		tfH.setOnAction((event)-> {
		    doCalc();
		});
    }

	void doCalc(){
		double h; //gf[^
		try{ //gf[^擾
			h = Double.parseDouble(tfH.getText()); //double^ɕϊ
		} catch (NumberFormatException error){ h = 0.0; } 
		if(h > 0){
			double std = h/100 * h/100 * 22;//W̏dvZ
			laStdW.setText(String.format("%.2f", std));//W̏d\
		}
	}
	
	public static void main(String[] args) {
		launch(args);
    }
    
}
