// ̃_XAj[V@t
import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.*; //Pane
import javafx.scene.canvas.*;  //Canvas, GraphicsContext
import javafx.scene.image.*; //Image
import javafx.animation.*;
import javafx.scene.media.AudioClip;

public class RabbitAnimation2 extends Application {
	Canvas canvas;
	int number = 0;       //\摜̔ԍ
	int cell = 20;        //摜̐
	Image[] image;        //摜i[z
	Image back;           //wi摜pϐ
	long prevTime;        //Õt[`(imb)
	AnimationTimer timer;
	AudioClip audio;
	@Override
	public void start(Stage stage) {
		back = new Image("rabbit/stage.png");
		image = new Image[cell];
		for (int i = 1; i <= cell; i++) {   //摜̃[h
			image[i-1] = new Image("rabbit/rabbit" + i + ".png");
		}
		//t@C̃[hCRXgN^ɂ́C΃pXw
		audio = new AudioClip(getClass().getResource("/rabbitdance.mp3").toString());
		audio.setCycleCount(AudioClip.INDEFINITE); //JԂ

		Pane root = new Pane();
		canvas = new Canvas(back.getWidth(), back.getHeight());
		root.getChildren().add(canvas);
        Scene scene = new Scene(root);
        stage.setTitle("Rabbit Animation");
        stage.setScene(scene);
        stage.show();
		timer = new AnimationTimer() { //^C}[̐
			@Override public void handle(long now){
				if (prevTime + 200_000_000 > now) return;  //0.2bo߂ĂȂΖ߂
					prevTime = now;
					drawCanvas(); //`
				}
			};
		timer.start();   //Aj[V̊Jn
		audio.play();   //̍Đ
    }

	void drawCanvas() {
		GraphicsContext gc = canvas.getGraphicsContext2D();
		gc.drawImage(back, 0, 0);
		double x = gc.getCanvas().getWidth()/2-30; //EBhÊقڒɂ\
		double y = gc.getCanvas().getHeight()/2+20;
        gc.drawImage(image[number], x, y);
		number++;  
		number = number%cell;  //ɕ\摜̔ԍ
    }

	public static void main(String... args) {
		launch(args);
	} 
}