public class Calendar {
	int gantan;
    int[] mon = {0,31,28,31,30,31,30,31,31,30,31,30,31};
    String[] week = {"j", "j", "Ηj", "j", "ؗj", "j", "yj"};  // K 7.6
    public static void main(String[] args){
        Calendar c;
        int year = 2017;
        if(args.length > 0){  // K 6.17 Œǉ
             year = Integer.parseInt(args[0]);
            c = new Calendar(year); 
        }else{
            c = new Calendar(0,  false);  // 2017 N̏ꍇCPP͓jŉ[Nł͂Ȃ
        }
        System.out.println("4  1 " + c.wday(4, 1));
        System.out.print("Ȃ킿");
        c.showWday(4,1);
        System.out.println("4 ̃J_[");
        c.showCalendar(4);
        System.out.println(year + "ÑJ_[");
        c.showCalendar();
	}
   
    Calendar(int gantan, boolean leap){
		this.gantan = gantan;
		if(leap) mon[2]=29;
	}	
    int numdays(int m, int d){
    	  	int sum = 0;
    	  	for(int i = 1; i < m; i++){
    	  		sum += mon[i];
    	  	}
    	  	sum += d;
    	  	return sum;
    }
    int wday(int m, int d){
    	   return (numdays(m,d) - 1 + gantan) % 7;
    }
    void showWday(int m, int d){
    	   System.out.println(week[wday(m,d)]);
    }
    void showCalendar(int m){
        int k = wday(m, 1);
        for(int i = 0; i < k; i++) System.out.print("   ");
        for(int i = 1; i <= mon[m]; i++){
            System.out.format("%3d", i);
            if(wday(m, i)== 6 && i < mon[m]) System.out.println("");
        }
        System.out.println("");
        System.out.println("");
    }
    void showCalendar(){
        for(int m = 1; m < 13; m++){
            System.out.println("         "+m + "");
            showCalendar(m);
        }
    }
    
    // K 7.21 Œǉ
    Calendar(int year){
        int days = 0;
        for(int y = 1900; y < year; y++){
            if(leap(y)){
                days += 366;
            }else{
                days += 365;
            }
        }
        this.gantan = (days + 1) % 7;
        if(leap(year)) mon[2] = 29;
    }
    boolean leap(int y){
        return ((y % 4 == 0 && y % 100 != 0) || y % 400 == 0);
    }
}
