// Hello New Layout (using VBox)
import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.control.*;  // Button, Label
import javafx.scene.layout.*;  //Pane
import javafx.geometry.*;  //Pos
 
public class HelloNewLayout22 extends Application {
	@Override
	public void start(Stage pstage) {
		Button b1 = new Button("{^1");
		Button b2 = new Button("{^Q");
		Label label = new Label("ɂ");
		b1.setMaxSize(Double.MAX_VALUE, Double.MAX_VALUE);   // ő啝ݒ
		b2.setMaxSize(Double.MAX_VALUE, Double.MAX_VALUE);
		label.setMaxSize(Double.MAX_VALUE, Double.MAX_VALUE);
		
		HBox hb = new HBox();
		hb.getChildren().add(b1); 
		hb.getChildren().add(b2);
		HBox.setHgrow(b1, Priority.ALWAYS);  //qm[hL
		HBox.setHgrow(b2, Priority.ALWAYS);
		hb.setAlignment(Pos.CENTER); //zu𒆉
		
		VBox root = new VBox();
		root.getChildren().add(label);
		root.getChildren().add(hb);

		VBox.setVgrow(label, Priority.ALWAYS);  //qm[hL
		VBox.setVgrow(hb, Priority.ALWAYS);
		root.setAlignment(Pos.CENTER); //zu𒆉
		Scene scene = new Scene(root);

		pstage.setTitle("New Layout 2");
		pstage.setScene(scene);
		pstage.sizeToScene();
		pstage.show();
	}
	public static void main(String[] args) {
		launch(args);
	}
}
