// Pbg{[ t
import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.*;  //Pane
import javafx.scene.canvas.*;  //Canvas, GraphicsContext
import javafx.animation.*;
import javafx.scene.paint.*; //Color
import javafx.scene.media.AudioClip;

public class RacketBall2 extends Application {
	Canvas canvas;
	double w = 400;  // ʃTCY
	double h = 400;
	double x = 0; // {[XW
	double y = 0;   // {[YW
	double diameter = 10.0; // {[a
	double speedX = 2; // {[Xx
	double speedY = 2; // {[Yx
	double directionX = 1; // {[Xړ
	double directionY = -1; // {[Yړ
	double racketW = 50, racketH = 20;  //Pbg̕
	double rx;  //Pbg̍̈ʒu
	double ry = h-50; //Pbg̏ォ̈ʒu
	int point=0;
	double gh=10, gw=80;  //S[̕
	double gx = w/2-gw/2, gy=0;  //S[̈ʒu
	boolean gameover = false;
	AnimationTimer timer;
	AudioClip audio;
	@Override
	public void start(Stage stage) {
		Pane root = new Pane();
		canvas = new Canvas(w, h);
		root.getChildren().add(canvas);
		Scene scene = new Scene(root);
		stage.setTitle("Racket Ball");
		stage.setScene(scene);
		stage.show();
		audio = new AudioClip(getClass().getResource("/ballhit.mp3").toString()); //t@C̃[h
			
		timer = new AnimationTimer() { //^C}[̐
			@Override public void handle(long now){
				drawCanvas();
			}
		};
		timer.start();   //Aj[V̊Jn
		canvas.setOnMouseMoved((event) -> { 
			rx = event.getX() - racketW/2;
		});
	
		canvas.setOnMouseClicked((event) -> { 
			if(gameover){
				gameover = false;
				x = 0;
				y = 0;
				point = 0;
				timer.start();   //Aj[V̊Jn
			}
		});
    }

	void drawCanvas() {
		GraphicsContext gc = canvas.getGraphicsContext2D();
		if(gameover){
			timer.stop();
			gc.strokeText("Game over",w/2-40, h/2); 
	 	 return;
		}
		gc.clearRect(0, 0, w, h);  // wih
		x += speedX * directionX;  // WvZ
		y += speedY * directionY;
		if (x > w-diameter) {   // E̕
			x = w - diameter;
			directionX = -directionX; // xϊ
			speedX = Math.random()*6+2;
			speedY = Math.random()*3+2;
		} else if (x < 0) { // ̕
			x = 0;
			directionX = -directionX; // xϊ
			speedX = Math.random()*6+2;
			speedY = Math.random()*3+2;
		}
		if (y > ry-diameter && y < ry+20 &&  x > rx && x < rx+racketW) { //Pbg\
			audio.play();
			y = ry-diameter;
			directionY = -directionY; // yϊ
			speedX = Math.random()*6+2;
			speedY = Math.random()*3+2;
		}else if (y > h-diameter) { //̕
			gameover = true;
		}else if (y < 0) {     // ̕
			if(x>gx && x<gx+gw) point=point +1; //S[ɓ
			y = 0;
			directionY = -directionY; // yϊ
			speedX = Math.random()*6+2;
			speedY = Math.random()*3+2;
		}
		gc.setFill(Color.RED);
		gc.fillOval(x, y, diameter, diameter);   //~
		gc.strokeText("Point: " + point, 10, 30);
		gc.setFill(Color.DARKGREY);
		gc.fillRect(gx, gy, gw, gh);      //goal
		gc.setFill(Color.DODGERBLUE);
		gc.fillRect(rx, ry, racketW, racketH); //racket
	}

	public static void main(String... args) {
		launch(args);
    } 
}