
//URL gHTTP NCAg VCf[^փANZX GUI
//  RpCɂjson͗pjart@Cw
//  javac -classpath json-simple-1.1.1.jar WeatherClientGUI.java 
//  java -classpath .:json-simple-1.1.1.jar WeatherClientGUI

import javafx.application.Application;
import javafx.event.*;  //ActionEvent
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.control.*;   // Label etc.
import javafx.scene.layout.*;  //VBox
import javafx.scene.image.*; //Image, ImageView

import java.io.*;
import java.net.*;
import org.json.simple.*;
import org.json.simple.parser.*;

public class WeatherClientGUI extends Application {
    Label laPlace, laTemp, laMax, laMin, laHumi, laTenki;
    
    @Override
    public void start(Stage pstage) {
        //x
        laPlace = new Label("ꏊɎw"); //VC\x
        laTenki = new Label(" "); //VC\x
        laTenki.setPrefHeight(50);
        laTemp = new Label(" "); //C\x
        laMax = new Label(" "); //ōC\x
        laMin = new Label(" "); //ŒC\x
        laHumi = new Label(" "); //x\x
        GridPane gpane = new GridPane();
        gpane.addRow(0, new Label("C"), laTemp);
        gpane.addRow(1, new Label("ōC"), laMax);
        gpane.addRow(2, new Label("ŒC"), laMin);
        gpane.addRow(3, new Label("x"), laHumi);
        //`CX{bNX
        ComboBox <String> cb  = new ComboBox<String>();
        cb.setEditable(true);
        cb.getItems().addAll("Tokyo", "Toyohashi", "Kyoto", "Tsukuba");
        //Reiɔzu
        VBox root = new VBox();
        root.getChildren().addAll(cb, laPlace, laTenki, gpane);  
        //X^Cw
        gpane.getStyleClass().add("gridpane");
        cb.getStyleClass().add("combobox");
        root.getStyleClass().add("vbox");
        Scene scene = new Scene(root);
        scene.getStylesheets().add("comboBoxEvent.css");
        pstage.setTitle("Show Weather");
        pstage.setScene(scene);
        pstage.show();

        //Action Eventnh̐ݒ
        cb.setOnAction( (ActionEvent event)-> {
            String item = cb.getSelectionModel().getSelectedItem();
	        try {
	           accessToWeather(item);
	        }catch(IOException e){ System.out.println("openweather̃f[^擾Ɏs"); }
        });
    }
    
    void accessToWeather(String city) throws IOException {
        String host = "api.openweathermap.org/data/2.5/weather?q=";
        String key = "5bbb22c664c****";  //擾APIL[
        URL url = new URL("http://" + host + city + ",jp&units=metric&appid=" + key);
        BufferedReader in = new BufferedReader(new InputStreamReader(url.openStream()));
        String line = in.readLine();
        //System.out.println(line);
        in.close();
        parseJSON(line);   
      }
    
    void parseJSON(String data){
        JSONObject obj = null;
        JSONParser parser = new JSONParser();
        try{
            obj = (JSONObject)parser.parse(data); 
        }catch(ParseException e){ }

        // n_
        String cityName = (String)obj.get("name");
        laPlace.setText(cityName);
        // C
        JSONObject mainObj = (JSONObject)obj.get("main");
        double currentTemp = Double.valueOf(String.valueOf(mainObj.get("temp")));
        double minTemp = Double.valueOf(String.valueOf(mainObj.get("temp_min")));
        double maxTemp = Double.valueOf(String.valueOf(mainObj.get("temp_max")));
        laTemp.setText(String.valueOf(currentTemp));
        laMax.setText(String.valueOf(maxTemp));
        laMin.setText(String.valueOf(minTemp));
        // x
        long humidity = (long)mainObj.get("humidity");
        laHumi.setText(String.valueOf(humidity));
        // VC
        JSONArray weatherArray =  (JSONArray)obj.get("weather");
        JSONObject weatherObj = (JSONObject)weatherArray.get(0);
        String weather = (String)weatherObj.get("main");
        laTenki.setText(weather);
        //VCACR
        String icon = (String)weatherObj.get("icon");
        laTenki.setGraphic(new ImageView("http://openweathermap.org/img/w/" + icon + ".png"));
    }
   
    public static void main(String[] args) {
        launch(args);
    }
}